"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const md5_1 = __importDefault(require("md5"));
const persistors_1 = __importDefault(require("../persistors"));
const cache = (config) => {
    const persistor = persistors_1.default.create(config);
    const getKey = (url) => (0, md5_1.default)(url);
    const cache = {
        has: (url) => __awaiter(void 0, void 0, void 0, function* () {
            return persistor.has(getKey(url));
        }),
        get: (url) => __awaiter(void 0, void 0, void 0, function* () { return persistor.read(getKey(url)); }),
        set: (url, result) => __awaiter(void 0, void 0, void 0, function* () {
            return persistor.save(getKey(url), result.data);
        }),
    };
    return cache;
};
exports.default = cache;
