"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ONE_YEAR = 60 * 60 * 24 * 365;
const defaultConfig = {
    caches: {
        input: {
            type: 'none',
            options: null,
        },
        output: {
            type: 'memory',
            options: {
                limit: 100,
            },
        },
    },
    browserCache: {
        maxAge: ONE_YEAR,
    },
    whitelist: [],
    errors: 'html',
    logger: {
        options: {
            level: process.env.LOG_LEVEL || 'debug',
            prettyPrint: true,
        },
        destination: process.stdout,
    },
    compress: false,
    defaultOperations: [{ operation: 'progressive', value: 'true' }],
};
exports.default = defaultConfig;
