"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.caravaggio = void 0;
const logger_1 = __importDefault(require("./logger"));
const pluginLoader_1 = __importDefault(require("./pluginLoader/pluginLoader"));
const microrouter_1 = require("microrouter");
const routes_1 = __importDefault(require("./routes"));
const misc_1 = require("./utils/misc");
const errorHandler_1 = __importDefault(require("./middlewares/errorHandler"));
const favicon_1 = __importDefault(require("./routes/favicon"));
const caravaggio = (config) => {
    const logger = (0, logger_1.default)(config);
    const pluginManager = (0, pluginLoader_1.default)(config, logger);
    const context = {
        config,
        logger,
        pluginManager,
    };
    return (0, microrouter_1.router)((0, microrouter_1.get)('/favicon.ico', favicon_1.default), (0, microrouter_1.get)('/**', (0, misc_1.compose)((0, errorHandler_1.default)(context), ...pluginManager.getMiddlewares())((0, routes_1.default)(context))));
};
exports.caravaggio = caravaggio;
exports.default = exports.caravaggio;
