"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMainLogger = void 0;
const pino_1 = __importDefault(require("pino"));
let logger;
const createLogger = (config) => {
    if (logger)
        return logger;
    const { logger: { options = {}, destination = process.stdout } = {
        destination: process.stdout,
        options: {},
    }, } = config;
    logger = (0, pino_1.default)(options, destination);
    return logger;
};
const getMainLogger = () => logger;
exports.getMainLogger = getMainLogger;
exports.default = createLogger;
