"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const cohercer_1 = __importDefault(require("../utils/cohercer"));
const blur = ({ value }) => {
    const v = (0, cohercer_1.default)(value, 'Blur must be a value between 0.3 and 1000.', 'blur.html')
        .toFloat()
        .min(0.3)
        .max(1000)
        .value();
    return [
        {
            name: 'blur',
            op: ({ image: sharp }) => __awaiter(void 0, void 0, void 0, function* () { return sharp.blur(v); }),
            params: [v],
        },
    ];
};
exports.default = blur;
