"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const cohercer_1 = __importDefault(require("../utils/cohercer"));
const misc_1 = require("../utils/misc");
function isImageWidthAvailable(iw, isPercentageWidth, isPercentageLeft) {
    return iw !== undefined || (!isPercentageWidth && !isPercentageLeft);
}
function isImageHeightAvailable(ih, isPercentageHeight, isPercentageTop) {
    return ih !== undefined || (!isPercentageHeight && !isPercentageTop);
}
const extract = ({ x, y, w, h }) => {
    const left = (0, cohercer_1.default)(x, 'Extract: the x parameter in in the wrong format.', 'extract.html')
        .toFloat()
        .value();
    const top = (0, cohercer_1.default)(y, 'Extract: the y parameter in in the wrong format.', 'extract.html')
        .toFloat()
        .value();
    const width = (0, cohercer_1.default)(w, 'Extract: the y parameter in in the wrong format.', 'extract.html')
        .toFloat()
        .value();
    const height = (0, cohercer_1.default)(h, 'Extract: the y parameter in in the wrong format.', 'extract.html')
        .toFloat()
        .value();
    return [
        {
            name: 'extract',
            op: ({ image }) => __awaiter(void 0, void 0, void 0, function* () {
                // const [width, height] = await getWidthAndHeight(s, image);
                const { width: iw, height: ih } = yield image.metadata();
                const isPercentageTop = (0, misc_1.isPercentage)(y);
                const isPercentageLeft = (0, misc_1.isPercentage)(x);
                const isPercentageWidth = (0, misc_1.isPercentage)(w);
                const isPercentageHeight = (0, misc_1.isPercentage)(h);
                if (!isImageWidthAvailable(iw, isPercentageWidth, isPercentageLeft)) {
                    throw new Error('Cannot extract percentage described portion for this image which size is not defined');
                }
                if (!isImageHeightAvailable(ih, isPercentageHeight, isPercentageTop)) {
                    throw new Error('Cannot extract percentage described portion for this image which size is not defined');
                }
                const extractOptions = {
                    left: isPercentageLeft ? (0, misc_1.percentageToPixel)(left, iw) : left,
                    top: isPercentageTop ? (0, misc_1.percentageToPixel)(top, ih) : top,
                    width: isPercentageWidth ? (0, misc_1.percentageToPixel)(width, iw) : width,
                    height: isPercentageHeight ? (0, misc_1.percentageToPixel)(height, ih) : height,
                };
                return image.extract(extractOptions);
            }),
            params: [
                {
                    left,
                    top,
                    width,
                    height,
                },
            ],
        },
    ];
};
exports.default = extract;
