import { Sharp } from 'sharp';
import { RawOperation } from '../utils/operationParser';
import { Context } from '..';
import { ServerRequest } from 'microrouter';
import { CacheControlStrategy } from '../utils/sender';
export interface Operation {
    name: string;
    op: (opt: {
        image: Sharp;
        otherOps: Array<Operation>;
        req: ServerRequest;
    }) => Promise<Sharp>;
    params: Array<unknown>;
    cacheStrategy?: CacheControlStrategy;
}
export declare type Normalizer<O extends RawOperation = RawOperation> = (rawOp: O) => Operation[];
declare const normalizer: (context: Context) => {
    normalize: (rawOperations: Array<RawOperation>) => Operation[];
};
export default normalizer;
