"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const cohercer_1 = __importDefault(require("../utils/cohercer"));
const WEBP_ACCEPT_REGEXP = /image\/webp/i;
const o = ({ value }) => {
    const format = (0, cohercer_1.default)(value, 'Accepted values are "original", jpg", "jpeg", "png", "webp", "tiff".', 'output.html')
        .toString()
        .enum(['original', 'jpg', 'jpeg', 'png', 'webp', 'tiff', 'avif', 'auto'])
        .value()
        .toLowerCase();
    let fn;
    switch (format) {
        case 'jpg':
        case 'jpeg':
            fn = ({ image }) => __awaiter(void 0, void 0, void 0, function* () { return image.jpeg(); });
            break;
        case 'png':
        case 'webp':
        case 'tiff':
            fn = ({ image }) => __awaiter(void 0, void 0, void 0, function* () { return image[format](); });
            break;
        case 'avif':
            fn = ({ image }) => __awaiter(void 0, void 0, void 0, function* () { return image.toFormat(format); });
            break;
        case 'auto':
            fn = ({ image, req }) => __awaiter(void 0, void 0, void 0, function* () {
                var _a;
                if (WEBP_ACCEPT_REGEXP.test(((_a = req.headers) === null || _a === void 0 ? void 0 : _a.accept) || '')) {
                    return image.webp();
                }
                return image;
            });
            break;
        default:
            return [];
    }
    return [
        {
            name: 'o',
            op: fn,
            params: [format],
            cacheStrategy: format === 'auto' ? 'private' : 'public',
        },
    ];
};
exports.default = o;
