"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const cohercer_1 = __importDefault(require("../utils/cohercer"));
const misc_1 = require("../utils/misc");
const progressive = ({ value }) => {
    const progressive = (0, cohercer_1.default)(value, 'Progressive value is not valid.', 'progressive.html')
        .toBool()
        .value();
    return [
        {
            name: 'progressive',
            op: ({ image, otherOps }) => __awaiter(void 0, void 0, void 0, function* () {
                const format = yield (0, misc_1.getOutputType)(image, otherOps);
                switch (format) {
                    case 'jpeg':
                    case 'jpg':
                        return image.jpeg({ progressive });
                    case 'png':
                        return image.png({ progressive });
                    default:
                        return image;
                }
            }),
            params: [progressive],
        },
    ];
};
exports.default = progressive;
