"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const cohercer_1 = __importDefault(require("../utils/cohercer"));
const colors_1 = require("../utils/colors");
const rotate = ({ v, b }) => {
    let angle;
    if (v !== 'auto') {
        angle = (0, cohercer_1.default)(v, 'Angle must be a number', 'rotate.html')
            .toInt()
            .value();
    }
    else {
        angle = undefined;
    }
    const options = {};
    if (b) {
        options.background = (0, colors_1.getColorFromParameter)(b);
    }
    return [
        {
            name: 'rotate',
            op: ({ image }) => __awaiter(void 0, void 0, void 0, function* () { return image.rotate(angle, options); }),
            params: [angle, options],
        },
    ];
};
exports.default = rotate;
