/// <reference types="node" />
import { FileCacheOptions, MemoryCacheOptions, NoneCacheOptions } from '../config/default';
export declare type CacheArtifactType = 'buffer';
export declare type CacheArtifact = {
    type: CacheArtifactType;
    data: Buffer;
};
export interface Persistor {
    flush?: () => Promise<void>;
    has: (key: string) => Promise<boolean>;
    read: (key: string) => Promise<CacheArtifact | null>;
    save: (key: string, buf: Buffer) => Promise<CacheArtifact>;
}
declare type CreateOptions = {
    type: 'file';
    options: FileCacheOptions;
} | {
    type: 'memory';
    options: MemoryCacheOptions;
} | {
    type: 'none';
    options: NoneCacheOptions;
};
declare const _default: {
    create: ({ type, options }: CreateOptions) => Persistor;
};
export default _default;
