"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const file_1 = __importDefault(require("./file"));
const memory_1 = __importDefault(require("./memory"));
const none_1 = __importDefault(require("./none"));
const basePersitorByType = {
    file: file_1.default,
    memory: memory_1.default,
    none: none_1.default,
};
exports.default = {
    create: ({ type, options = {} }) => {
        switch (type) {
            case 'file':
                return basePersitorByType.file(options);
            case 'memory':
                return basePersitorByType.memory(options);
            case 'none':
                return basePersitorByType.none(options);
            default:
                throw new Error(`Unknown persistor type ${type}. Check your configuration`);
        }
    },
};
