"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const BToMB = (B) => Math.round((B / 1024 / 1024) * 100) / 100;
const memoryPersistor = ({ limit } = { limit: 100 }) => {
    const fileCache = new Map();
    let size = 0;
    const checkMemory = (filename) => {
        if (limit && limit > 0 && size > limit) {
            const next = fileCache.keys().next();
            if (!next.done) {
                const first = next.value;
                if (first !== filename) {
                    fileCache.delete(first);
                }
            }
        }
    };
    const increaseSize = (length) => {
        size += BToMB(length);
    };
    const cache = {
        flush: () => __awaiter(void 0, void 0, void 0, function* () {
            fileCache.clear();
            size = 0;
        }),
        has: (filename) => __awaiter(void 0, void 0, void 0, function* () { return fileCache.has(filename); }),
        read: (filename) => __awaiter(void 0, void 0, void 0, function* () {
            return fileCache.has(filename)
                ? {
                    type: 'buffer',
                    data: fileCache.get(filename),
                }
                : null;
        }),
        save: (filename, buffer) => __awaiter(void 0, void 0, void 0, function* () {
            fileCache.set(filename, buffer);
            increaseSize(buffer.length);
            checkMemory(filename);
            return {
                type: 'buffer',
                data: buffer,
            };
        }),
    };
    return cache;
};
exports.default = memoryPersistor;
