/// <reference types="node" />
import { RawOperation } from '../utils/operationParser';
import { Context } from '..';
import { Operation } from '../normalizers';
import { ServerRequest } from 'microrouter';
import type { CacheControlStrategy } from '../utils/sender';
export interface PipelineResult {
    data: Buffer;
    format?: string;
    cacheStrategy?: CacheControlStrategy;
}
export declare type Pipeline = (opt: {
    url: string;
    rawOperations: Array<RawOperation>;
    req: ServerRequest;
}) => Promise<PipelineResult>;
/**
 * Returns the strict-est cache strategy
 */
export declare const strictestCacheStrategy: (operations: Operation[]) => CacheControlStrategy;
declare const pipelineCreator: (context: Context) => Pipeline;
export default pipelineCreator;
