"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const micro_1 = require("micro");
let favicon = null;
const getFavicon = () => __awaiter(void 0, void 0, void 0, function* () {
    if (!favicon) {
        favicon = yield fs_extra_1.default.readFile(path_1.default.resolve(__dirname, '..', '..', 'static', 'favicon.ico'));
    }
    return favicon;
});
const faviconRoute = (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    res.setHeader('cache-control', 'max-age=84600, public');
    res.setHeader('content-type', 'image/x-icon');
    (0, micro_1.send)(res, 200, yield getFavicon());
});
exports.default = faviconRoute;
