"use strict";
/* eslint-env jest */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initialise = void 0;
const node_fetch_1 = __importDefault(require("node-fetch"));
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const got_1 = __importDefault(require("got"));
const configuring_1 = require("configuring");
const default_1 = __importDefault(require("../../config/default"));
const test_1 = __importDefault(require("../../config/test"));
const fs = fs_1.default.promises;
const cache = new Map();
node_fetch_1.default.mockImplementation((url) => __awaiter(void 0, void 0, void 0, function* () {
    const knownLocation = 'https://caravaggio.ramielcreations.com/docs/assets/example';
    if (url.indexOf(knownLocation) === 0) {
        const relativePath = url.slice(knownLocation.length);
        let data;
        if (cache.has(relativePath)) {
            data = cache.get(relativePath);
        }
        else {
            data = yield fs.readFile(path_1.default.join(__dirname, '..', 'fixtures', 'test-images', relativePath));
            cache.set(relativePath, data);
        }
        return { buffer: () => __awaiter(void 0, void 0, void 0, function* () { return data; }) };
    }
    const response = yield (0, got_1.default)(url, {});
    return { buffer: () => response.body };
}));
const initialise = () => {
    const configManager = (0, configuring_1.createConfigManager)({
        configurations: {
            default: default_1.default,
            test: test_1.default,
        },
    });
    return configManager;
};
exports.initialise = initialise;
