/**
 * Given an array of async functions, return a function that takes the same argument as each function
 * in the array. Each function is executed in series and the first that doesn't crash, returns the
 * value
 * @param fns Array of async functions
 */
export declare const tryEach: <T, TArgs extends unknown[]>(fns: ((...args: TArgs) => Promise<T | null>)[], opt?: {
    onError?: ((e: Error) => void) | undefined;
    ignoreResult?: ((result: unknown) => boolean) | undefined;
} | undefined) => (...args: TArgs) => Promise<T | null>;
