export interface RawOperation {
    operation: string;
    [key: string]: string | undefined;
}
declare type OperationParser = (path: string, opt?: {
    OPERATION_DELIMITER?: string;
    KEY_VALUE_DELIMITER?: string;
    OPTION_DELIMITER?: string;
}) => Array<RawOperation>;
/**
 * Transform an url into a series of operations following the rules described
 * [here](https://gitlab.com/ramiel/caravaggio/-/issues/29)
 * @param path URL pathname to transform into operations
 * @param opt Define delimiter characters
 */
declare const operationParser: OperationParser;
export default operationParser;
